Die in STERNE verwendeten Variablen und ihre Bedeutung:

Vorbemerkung: Variablen des Typs Werte, der in der Unit Star Global def.
              wurde, beschreiben immer eine Konstellation von 14 Sternen.

SternApp        : tSternApp;         Variablen der Objekttypen
Ereigniss       : tEvent;
EingabeFenster  : pDialog;

Star0           : Werte;             Konstant alle Sterndaten = 0
i,j             : integer;           Laufvar. fr Schleifen


DatAktu         : PathStr;           Pfad der aktuelle Sterndaten
DatSave         : PathStr;           Pfad, unter dem gespeichert werden soll

StarAktu        : Werte;             Aktuelle Sterndaten
AnzSterne       : integer;           Anzahl der Sterne <> 0
itera           : longint;           Anzahl der Iterationsschritte
genau           : longint;           Genauigkeit fr Iteration und Schrittweite

Die letzten vier Variablen werden zur Laufzeit des Programms stndig
 aktualisiert und berschrieben und enthalten die Daten, auf die beim Start
 des Sternbewegungsprogramms zugegriffen wird.



Die Module des Programms:

Procedure AnzahlSterne(Sterne:Werte; var Anzahl:integer);
  Gibt fr die angegebenen Sterne die Anzahl der Werte <> 0 an.
  Zhlt als Anzahl nur die Sterne durch, bis die erste Masse 0 ist.

Procedure DateiLesen(SternDatei:PathStr;var Sterne:Werte);
  Liest die Werte der externen Datei SternDatei und belegt damit
  die Variable Sterne.

Procedure tSternApp.FileSearchOpen;
  ffnet Dateiauswahlfenster und nach der Wahl die gewnschte Datei

Function DatenTest(Anzahl:integer;Sterne:Werte):boolean;
  Testet die aktuellen Werte in Sterne und Anzahl auf unzulssige
  Daten und meldet Fehler.

Procedure DateiSchreiben(SternDatei:PathStr; Sterne:Werte);
  Schreibt die Werte der Variablen Sterne in die unter SternDatei
  angegebene Datei.

Procedure tSternApp.SaveAs;
  ffnet Dateiauswahlfenster zur Speicherung und prft den gewhlten Pfad
  auf seine Gltigkeit.

Procedure tSternApp.WoSpeichern;
  Fragt ab, ob eine bestehende Datei mit neuen Werten berschrieben
  werden soll.

Procedure tSternApp.Speichern;
  Je nach aktuellem Stand der internen Daten wird SaveAs oder
  WoSpeichern (s.o.) aufgerufen.

Procedure MachEingabe(Titel,Vor:String;max:integer;var Fenster:pDialog);
  Gibt in Fenster Pointer fr ein Eingabefenster einer Integerzahl aus.
  Titel und Vor sind die Beschriftungen des Fensters und max grenzt den
  zulssigen Bereich der Integerzahl ein.

Procedure SternEingabe(Anzahl:integer; Titel:String; var Fenster:pDialog);
  Als Fenster wird ein Pointer fr ein Eingabefenster ausgegeben, in dem
  alle Daten einer Sternkonstellation eingetragen werden knnen.
  In Titel wird die berschrift des Fensters und in Anzahl die Anzahl der
  Sterne bergeben.

Constructor tSternApp.Init;
  Constructor von tSternApp mit Belegung der Anfangswerte.    

Procedure tSternApp.InitMenuBar;
  Einrichten der Menleiste.

procedure tSternApp.InitStatusLine;
  Einrichten der Statuszeile.

Procedure tSternApp.HandleEvent;
  Steuert die Befehlsverwaltung des Programms.

  Procedure SternDaten(Anz:integer;Titel:String;Sterne:Werte);
    ffnet Eingabefenster fr Sterndaten und liest die Daten.
    Mit Titel wird die berschrift, mit Anz die Anzahl der
    Eingabezeilen fr die Sterndaten und mit Sterne die Vorbelegung
    der Eingabefenster bergeben.

  Procedure Gruss;
    ffnet MessageBox mit einem Gru.

  Procedure SternRun;
    Das Sternbewegungsprogramm wird mit den aktuellen Daten gestartet.

  Procedure AnzIt;
    Ruft das Eingabefenster fr Integerzahlen auf und belegt die Variable
    itera eventuell mit neuen Werten.

  Procedure GenauEin;
    Ruft das Eingabefenster fr Integerzahlen auf und belegt die Variable
    genau eventuell mit neuen Werten.

Begin
  SternApp.Init;
  SternApp.Run;
  SternApp.Done;
end.





Die in der Unit Star verwendeten Variablen und ihre Bedeutung:

Vorbemerkung: Die Unit enthlt nur die Prozedur Stern.

Type Werte = array[1..14,1..5] of real;
  Globale Typenbezeichnung, wird immer fr die Daten Masse, Position
  und Geschwindigkeit der Sterne benutzt.

Procedure Stern (Gen,maxit,Anz:longint; Sterne:werte; var Fehler:integer);
  Berechnet und zeichnet den Verlauf von Planetenbahnen nach den gegebenen
  Anfangswerten. Gen bezeichnet dabei den Exponenten der Genauigkeit und
  maxit die maximale Anzahl der Iterationen mit denen gerechnet werden soll.
  In Anz wird die Anzahl der Sterne und in Sterne ihre Daten bergeben.
  Fehler gibt an, ob das Programm abgebrochen wurde.


Die Variablen:

  xa,xb,xc,xd,xf                       Geben die Positionen und
  va,vc,vf                             die Geschwindigkeit der Sterne
                                       zu verschiedenen Zeiten an.
  xdiff                                Differenzvektor zweier Sternpositionen
  m                                    Massen der Sterne
  SchwPunkt                            Schwerpunkt der Sternkonstellation
  n                                    Anzahl der Sterne
  i,j,k,u,z                            Laufvariablen fr Schleifen
  gt,gm                                Werte fr Grafikmodus
  x,y,mitteX,mitteY,grenze,ReX,ReY     Werte fr Pixel auf Monitor
  Eps,genau                            Werte fr Genauigkeit
  h,hd                                 Werte fr Schrittweitensteuerung
  DeltaT                               Schrittweite
  b                                    Summe der Diff. bei fixpunktit.
  m_ges                                Gesamtmasse des Systems
  int                                  Abstand zweier Pixel fr Umrechnung
  Hilfs_var                            Hilfsvariable
  Dist_Xa,Dist_Xb                      Abstand zwischen Sternen